<?php
function getArchiveCalendarStyleScript($target) {
	global $suri, $pluginURL;
	$context = Model_Context::getInstance();
	$blogURL = $context->getProperty('uri.blog');

	$styleScript = "";
	if ($suri['directive'] == '/archive') {
		$styleScript .= '<link rel="stylesheet" type="text/css" media="screen" href="' . $pluginURL . '/style/archiveCalendar.css" />'.CRLF;
		$styleScript .= '<script type="text/javascript">var blogURL = "' . $blogURL . '";</script>'.CRLF;
		$styleScript .= '<script type="text/javascript" src="' . $pluginURL . '/script/archiveCalendar.js"></script>'.CRLF;
	}
	$target .= $styleScript;
	return $target;
}

function getArchiveCalendar($target, $mother) {
	global $view;
	requireComponent('Textcube.Function.Misc');
	requireComponent('Needlworks.Cache.PageCache');

	$context = Model_Context::getInstance();
	$blogid = $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$suriValue = $context->getProperty('suri.value');
	$suriDirective = $context->getProperty('suri.directive');

	if (!is_dir(ROOT."/cache/thumbnail")) {
		@mkdir(ROOT."/cache/thumbnail");
		@chmod(ROOT."/cache/thumbnail", 0777);
	}
	if (!is_dir(ROOT."/cache/thumbnail/" . $blogid)) {
		@mkdir(ROOT."/cache/thumbnail/" . $blogid);
		@chmod(ROOT."/cache/thumbnail/" . $blogid, 0777);
	}
	if (!is_dir(ROOT."/cache/thumbnail/" . $blogid . "/archiveCalendar/")) {
		@mkdir(ROOT."/cache/thumbnail/" . $blogid . "/archiveCalendar/");
		@chmod(ROOT."/cache/thumbnail/" . $blogid . "/archiveCalendar/", 0777);
	}

	$archiveCalendar  = ''.CRLF;
	if ($suriDirective == "/archive") {
		$period = (isset($suriValue) && !empty($suriValue)) ? $suriValue : Timestamp::getYearMonth();
		if (strlen($period) == 6 || strlen($period) == 4) {
			$cache = new pageCache;
			$cache->name = "ArchiveCalendar_" . $period;
			if ($cache->load()) {
				$archiveCalendar = $cache->contents;
			} else {
				$archiveCalendar  = '<div class="entryTop"></div>'.CRLF;
				$archiveCalendar .= '<div class="searchList result group">'.CRLF;
				$archiveCalendar .= '	<h3><strong>\'[##_list_conform_##]\' Archive Calendar</strong></h3>'.CRLF;
				$archiveCalendar .= '	<div class="box">'.CRLF;
				$archiveCalendar .= '	<div id="archiveCalendarContent">'.CRLF;
				if (strlen($period) == 4) {
					$archiveCalendar .= '<div class="archiveYearMonthList">'.CRLF;
					$archiveCalendar .= getArchiveYearMonthList($period);
					$archiveCalendar .= '</div>'.CRLF;
					$startPoint = $period . "01";
					$endPoint = $period . "12";
					$current = Timestamp::getYearMonth();
					for ($i = $startPoint; $i <= $endPoint; $i++) {
						$archiveCalendar .= getArchiveCalendarView(getCalendar($blogid, $i), 'year');
						if ($i == $current) break;
					}
				} else if (strlen($period) == 6) {
					$archiveCalendar .= getArchiveCalendarView(getCalendar($blogid, $period), 'month');
					$archiveCalendar .= '<div style="clear:both;"></div>'.CRLF;
					$archiveCalendar .= '<div class="archiveYearMonthList">'.CRLF;
					$archiveCalendar .= getArchiveYearMonthList($period);
					$archiveCalendar .= '</div>'.CRLF;
				}

				$archiveCalendar .= '	<div style="clear:both;"></div>'.CRLF;
				$archiveCalendar .= '	</div>'.CRLF;
				$archiveCalendar .= '	</div>'.CRLF;
				$archiveCalendar .= '</div>'.CRLF;
				$archiveCalendar .= '<div class="entryBottom"></div>'.CRLF;

				if (isset($cache)) { 
					$cache->name = "ArchiveCalendar_" . $period;
					$cache->contents = $archiveCalendar;
					$cache->dbContents = $archiveCalendar;
					$cache->update();
				}
			}
			unset($cache);

			Misc::dress('list_conform', Timestamp::format((strlen($period) == 4 ? '%Y년' : '%Y년 %m월'), getTimeFromPeriod($period)), $archiveCalendar);
			Misc::dress('paging', '', $view);
		}
		$target = $archiveCalendar;
	}
	return $target;
}

function getArchiveYearMonthList($period) {
	$context = Model_Context::getInstance();
	$dbPrefix = $context->getProperty('database.prefix');
	$blogid = $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');

	$visibility = doesHaveOwnership()?'':' AND visibility > 0 ' . getPrivateCategoryExclusionQuery($blogid);
	$years	= POD::queryAll("SELECT YEAR(FROM_UNIXTIME(published)) period, COUNT(*) count FROM {$dbPrefix}Entries WHERE blogid = $blogid AND draft = 0 {$visibility} AND category >= 0 GROUP BY period ORDER BY period DESC");
	if (strlen($period) == 4) {
		$yearMonthHtml  = '<ul class="yearList">'.CRLF;
		foreach ($years as $year) {
			if ($year['period'] == $period) {
				$yearMonthHtml .= '<li class="year">&nbsp;<b>' . $year['period'] . '</b></li>'.CRLF;
			} else {
				$yearMonthHtml .= '<li class="year">&nbsp;<a href="' . $blogURL . '/archive/' . $year['period'] . '">' . $year['period'] . '</a></li>'.CRLF;
			}
		}
		$yearMonthHtml .= '</ul>'.CRLF;
	} else {
		$yearMonthHtml  = '<ul class="yearList">'.CRLF;
		foreach ($years as $year) {
			$months = POD::queryAll("SELECT EXTRACT(YEAR_MONTH FROM FROM_UNIXTIME(published)) period, COUNT(DISTINCT DAYOFMONTH(FROM_UNIXTIME(published))) count FROM {$dbPrefix}Entries WHERE blogid = $blogid AND draft = 0 {$visibility} AND category >= 0 AND EXTRACT(YEAR FROM FROM_UNIXTIME(published)) = '" . $year['period'] . "' GROUP BY period ORDER BY period ASC");
			
			$yearMonthHtml .= '<li class="year monthJoin">&nbsp;<b>&bull;&nbsp;<a href="' . $blogURL . '/archive/' . $year['period'] . '">' . $year['period'] . '</a></b>'.CRLF;
			$yearMonthHtml .= '	<ul class="monthList">'.CRLF;
			foreach ($months as $month) {
				if ($month['period'] == $period) {
					$yearMonthHtml .= '<li class="month"><b>' . (int)substr($month['period'], 4 ,2) . '월(' . $month['count'] . ')</b>&nbsp;</li>';
				} else {
					$yearMonthHtml .= '<li class="month"><a href="' . $blogURL . '/archive/' . $month['period'] . '">' . (int)substr($month['period'], 4, 2) . '월(' . $month['count'] . ')</a>&nbsp;</li>';
				}
			}
			$yearMonthHtml .= '	</ul>'.CRLF;
			$yearMonthHtml .= '</li>'.CRLF;
		}
		$yearMonthHtml .= '</ul>'.CRLF;
	}

	return $yearMonthHtml;
}

function getArchiveCalendarDressProcess($target){
	global $skinSetting;

	$context = Model_Context::getInstance();
	$suriValue = $context->getProperty('suri.value');
	$suriDirective = $context->getProperty('suri.directive');

	if ($suriDirective == "/archive") {
		$period = (isset($suriValue) && !empty($suriValue)) ? $suriValue : Timestamp::getYearMonth();
		if (strlen($period) == 6 || strlen($period) == 4) {
			$skinSetting['showListOnArchive'] = 2;
		}
	}
	return $target;
}

function getArchiveCalendarView($calendar, $flag) {
	global $pluginURL;

	$context = Model_Context::getInstance();
	$blogURL = $context->getProperty('uri.blog');

	$current = $calendar['year'] . $calendar['month'];
	$previous = addPeriod($current, - 1);
	$next = addPeriod($current, 1);
	$firstWeekday = date('w', mktime(0, 0, 0, $calendar['month'], 1, $calendar['year']));
	$lastDay = date('t', mktime(0, 0, 0, $calendar['month'], 1, $calendar['year']));
	$today = ($current == Timestamp::get('Ym') ? Timestamp::get('j') : null);

	$currentMonthStr = Timestamp::format('%Y년 %m월', getTimeFromPeriod($current));
	$entryCount = count($calendar['days']);
	
	$maxWidthHeight = ($flag == 'year' ? 'width:178px;' : 'width:546px;');
	
	if ($flag == 'year') {
		if ($entryCount > 0) {
			$navigationBar  = '<a href="' . $blogURL . '/archive/' . $current . '" title="' . _text('현재 달의 달력을 보여줍니다.') . '">' . $currentMonthStr . '(' . $entryCount . ')</a>';
		} else {
			$navigationBar  = $currentMonthStr . '(' . $entryCount . ')';
		}
	} else {
		$navigationBar = '<a href="' . $blogURL . '/archive/' . $previous . '" title="' . _text('1개월 앞의 달력을 보여줍니다.') . '">&laquo;</a>&nbsp;';
		$navigationBar .= '&nbsp;<span class="currenMonth">' . $currentMonthStr . '(' . $entryCount . ')</span>&nbsp;&nbsp;';
		$navigationBar .= '<a href="' . $blogURL . '/archive/' . $next . '" title="' . _text('1개월 뒤의 달력을 보여줍니다.') . '">&raquo;</a>';
	}

	ob_start();
?>
<div class="archiveCalendar" style="<?php echo $maxWidthHeight;?>">
	<div class="entriesThumbnailList" style="display: none;">
		<div class="AC_ThumbnailList">
			<div class="AC_PreviewImage"></div>
		</div>
	</div>
	<div class="loading" style="display: none;"><div class="loadingImage"><img src="<?php echo $pluginURL?>/images/loading.gif"/></div></div>

	<div class="yearMonthTitle">
		<?php echo $navigationBar;?>
	</div>
	<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="#eeeeee"><tr><td style="border:2px solid #eeeeee;">
	<table class="calendar calendar_<?php echo $flag;?>" cellpadding="0" cellspacing="1" style="width: 100%; table-layout: fixed">
		<thead>
			<tr>
				<th class="calWeek2"><?php echo _text('일요일');?></th>
				<th class="calWeek1"><?php echo _text('월요일');?></th>
				<th class="calWeek1"><?php echo _text('화요일');?></th>
				<th class="calWeek1"><?php echo _text('수요일');?></th>
				<th class="calWeek1"><?php echo _text('목요일');?></th>
				<th class="calWeek1"><?php echo _text('금요일');?></th>
				<th class="calWeek3"><?php echo _text('토요일');?></th>
			</tr>
		</thead>
		<tbody>
<?php
	$day = 0;
	$totalDays = $firstWeekday + $lastDay;
	$lastWeek = ceil($totalDays / 7);
	$calendarHtml = '';
	$entriesInfo = array();

	for ($week=0; $week<$lastWeek; $week++) {
		// 주중에 현재 날짜가 포함되어 있으면 주를 현재 주 class(tt-current-week)를 부여한다.
		if (($today + $firstWeekday) > $week * 7 && ($today + $firstWeekday) <= ($week + 1) * 7) {
			$calendarHtml .= '		<tr class="calWeek cal_current_week">'.CRLF;
		} else {
			$calendarHtml .= '		<tr class="calWeek">'.CRLF;
		}

		for($weekday=0; $weekday<7; $weekday++) {
			$day++;
			$currentDate = $current . ($day > 9 ? $day : "0$day");
			if ($flag == 'month') {
				$dayString = isset($calendar['days'][$day]) ? '<span class="calClick">'.$day.'</span>' : $day;
			} else {
				$dayString = isset($calendar['days'][$day]) ? '<a href="#" class="calClick" rel="' . $currentDate . '">'.$day.'</a>' : $day;
			}
			$dayCheck = isset($calendar['days'][$day]) ? true : false;
			$entriesInfo = getArchiveCalendarEntries($currentDate);
			$entriesCount = $entriesInfo[0] . '개의 게시된 글이 있습니다.';

			if ($dayCheck === true && $flag == 'month') {
				$entriesImages = '				<img src="' . $entriesInfo[1] . '" class="entriesImages" rel="' . $currentDate . '" title="' . $entriesCount . '" />'.CRLF;
			} else if ($flag == 'month') {
				$entriesImages = '				<img src="' . $pluginURL . '/images/blank.gif" class="none_entriesImages" />';
			}
			$dayStringBlack = $day;
			
			if ($flag == 'month') {
				$dayStiingTag  = '				<div class="BlackDate">' . $dayStringBlack . '</div>'.CRLF;
				$dayStiingTag .= '				<div class="GrayDate">' . $dayString . '</div>'.CRLF;
			} else {
				$dayStiingTag  = '				<div class="GrayDate ' . ($dayCheck == true ? "entriesTrue" : "") . '" title="' . ($dayCheck == true ? $entriesCount : "") . '">' . $dayString . '</div>'.CRLF;
			}

			// 일요일, 평일, 토요일별로 class를 부여한다.
			switch ($weekday) {
				case 0:
					$className = " calDay calDaySunday";
					break;
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
					$className = " calDay";
					break;
				case 6:
					$className = " calDay calDaySaturday";
					break;
			}

			// 오늘에 현재 class(tt-current-day)를 부여한다.
			$className .= $day == $today ? " calDay4" : " calDay3";

			if ($week == 0) {
				if ($weekday < $firstWeekday) {
					$day--;
					// 달의 첫째날이 되기 전의 빈 칸.
					$calendarHtml .= '			<td class="calDay1">&nbsp;</td>'.CRLF;
				} else {
					$calendarHtml .= '			<td class="'.$className.'">'.CRLF;
					$calendarHtml .= $dayStiingTag;
					$calendarHtml .= $entriesImages;
					$calendarHtml .= '			</td>'.CRLF;
				}
			} else if ($week == ($lastWeek - 1)) {
				if ($day <= $lastDay) {
					$calendarHtml .= '			<td class="'.$className.'">'.CRLF;
					$calendarHtml .= $dayStiingTag;
					$calendarHtml .= $entriesImages;
					$calendarHtml .= '			</td>'.CRLF;
				} else {
					// 달의 마지막날을 넘어간 날짜 빈 칸.
					$calendarHtml .= '			<td class="calDay2">&nbsp;</td>'.CRLF;
				}
			} else {
				$calendarHtml .= '			<td class="'.$className.'">'.CRLF;
				$calendarHtml .= $dayStiingTag;
				$calendarHtml .= $entriesImages;
				$calendarHtml .= '			</td>'.CRLF;
			}
		}
		$calendarHtml .= '		</tr>'.CRLF;

		if ($day >= $lastDay) {
			break;
		}
	}
	if ($lastWeek < 6 && $flag == 'year') {
		if ($lastWeek == 4) {
			$lastWeek = 2;
		} else if ($lastWeek == 5) {
			$lastWeek = 1;
		}
		for ($i = 0; $i < $lastWeek; $i++) {
			$calendarHtml .= '		<tr class="calWeek"><td colspan="7" class=" calDay calDay3"><div class="GrayDate">&nbsp;</div></td></tr>'.CRLF;
		}
	}
	echo $calendarHtml;
?>
		</tbody>
	</table>
	</td></tr></table>
</div>
<?php
	$view = ob_get_contents();
	ob_end_clean();
	return $view;
}

function getArchiveCalendarEntries($target) {
	global $pluginURL;

	$context = Model_Context::getInstance();
	$blogid = $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$useSloganOnPost = $context->getProperty('blog.useSloganOnPost');
	$useEncodedURL = $context->getProperty('service.useEncodedURL');

	$period = strlen($target) == 8 ? $target : $_POST['period'];
	$condition  = " EXTRACT(YEAR_MONTH FROM FROM_UNIXTIME(published)) = '" . substr($period, 0, 6) . "' ";
	$condition .= " AND EXTRACT(DAY FROM FROM_UNIXTIME(published)) = '" . substr($period, 6, 2) . "' ";
	$entries = getEntries($blogid, 'id, title, slogan, content', $condition);
	$entriesHtml = "";
	$entriesFirstImage = array();

	$entriesHtml .= '<div class="AC_ThumbnailList">' . CRLF;
	foreach ($entries as $entry) {
		$permalink = "$blogURL/" . ($useSloganOnPost ? "entry/" . URL::encode($entry['slogan'], $useEncodedURL) : $entry['id']);
		$thumbnailImage = '';
		if ($imageName = getArchiveCalendarAttachmentExtract($entry['content'])) {
			if ($tempImageSrc = getArchiveCalendarImageResizer($blogid, $imageName, 75)) {
				array_push($entriesFirstImage, $tempImageSrc);
			}
		} else {
			$tempImageSrc = $pluginURL . '/images/noPostThumb.gif';
		}
		$entriesHtml .= '	<div class="AC_PreviewImage" title="' . htmlspecialchars($entry['title']) . '"><img class="previewImage" src="' . $tempImageSrc . '" rel="' . $permalink . '" alt="' . htmlspecialchars($entry['title']) . '" /></div>'.CRLF;
	}
	$entriesHtml .= '</div>' . CRLF;
	
	if (count($entriesFirstImage) < 1) {
		array_push($entriesFirstImage, $pluginURL . '/images/noPostThumb.gif');
	}

	if (strlen($target) == 8) {
		return array(count($entries), $entriesFirstImage[0]);
	} else {

	header('Content-Type: text/xml; charset=UTF-8');
	$result  = '<?xml version="1.0" encoding="utf-8"?><response>';
	$result .= '<archiveCalendarBody><![CDATA[' . $entriesHtml . ']]></archiveCalendarBody>';
	$result .= '</response>';
	echo $result;
	flush();
	}
}

function getArchiveCalendarAttachmentExtract($content){
	$result = null;
	if(preg_match_all('/\[##_(1R|1L|1C|2C|3C|iMazing|Gallery)\|[^|]*\.(gif|jpg|jpeg|png|bmp|GIF|JPG|JPEG|PNG|BMP)\|.*_##\]/si', $content, $matches)) {
		$split = explode("|", $matches[0][0]);
		$result = $split[1];
	}else if(preg_match_all('/<img[^>]+?src=("|\')?([^\'">]*?)("|\')/si', $content, $matches)) {
		if( stristr($matches[2][0], 'http://') ){
			$result = $matches[2][0];
		}
	}
	return $result;
}

function getArchiveCalendarImageResizer($blogid, $filename, $cropSize){
	$context = Model_Context::getInstance();
	$serviceURL = $context->getProperty('service.serviceURL');

	$tempFile = null;
	$thumbFilename = $filename;
	$imageURL = "{$serviceURL}/attach/{$blogid}/{$filename}";
	if (extension_loaded('gd')) {	
		if (stristr($filename, 'http://')) {
			$thumbFilename = getArchiveCalendarRemoteImageFilename($filename);
		}

		$thumbnailSrc = ROOT . "/cache/thumbnail/{$blogid}/archiveCalendar/th_{$thumbFilename}";
		if (!file_exists($thumbnailSrc)) {
			$imageURL = getArchiveCalendarCropProcess($blogid, $filename, $cropSize);
		} else {
			$imageURL = "{$serviceURL}/thumbnail/{$blogid}/archiveCalendar/th_{$thumbFilename}";
			$imageInfo = getimagesize($thumbnailSrc);
			if ($imageInfo[0] != $cropSize) {
				$imageURL = getArchiveCalendarCropProcess($blogid, $filename, $cropSize);
			}
		}
	} else {
		if(stristr($filename, 'http://') ){
			$imageURL = $filename;
		}
	}
	return $imageURL;
}

function getArchiveCalendarCropProcess($blogid, $filename, $cropSize) {
	$context = Model_Context::getInstance();
	$serviceURL = $context->getProperty('service.serviceURL');

	$tempFile = null;
	$imageURL = null;
	if(stristr($filename, 'http://') ){
		list($originSrc, $filename, $tempFile) = getArchiveCalendarCreateRemoteImage($blogid, $filename);
	} else {
		$originSrc = ROOT . "/attach/{$blogid}/{$filename}";
	}

	$thumbnailSrc = ROOT . "/cache/thumbnail/{$blogid}/archiveCalendar/th_{$filename}";
	if (file_exists($originSrc)) {
		requireComponent('Textcube.Function.Image');
		$imageInfo = getimagesize($originSrc);

		$objThumbnail = new Image();
		if ($imageInfo[0] > $imageInfo[1])
			list($tempWidth, $tempHeight) = $objThumbnail->calcOptimizedImageSize($imageInfo[0], $imageInfo[1], NULL, $cropSize);
		else
			list($tempWidth, $tempHeight) = $objThumbnail->calcOptimizedImageSize($imageInfo[0], $imageInfo[1], $cropSize, null);

		$objThumbnail->imageFile = $originSrc;
		if ($objThumbnail->resample($tempWidth, $tempHeight) && $objThumbnail->cropRectBySize($cropSize, $cropSize)) {
			$imageURL = "{$serviceURL}/thumbnail/{$blogid}/archiveCalendar/th_{$filename}";
			$objThumbnail->saveAsFile($thumbnailSrc);
		}

		unset($objThumbnail);
		if($tempFile) unlink($originSrc);
	} else {
		$imageURL = null;
	}

	return $imageURL;
}

function getArchiveCalendarCreateRemoteImage($blogid, $filename) {
	$fileObject = false;
	$tmpDirectory = ROOT . "/cache/thumbnail/{$blogid}/archiveCalendar/";
	$tempFilename = tempnam($tmpDirectory, "remote_");
	$fileObject = @fopen($tempFilename, "w");

	if ($fileObject) {
		$originSrc = $tempFilename;
		$remoteImage = getArchiveCalendarHTTPRemoteImage($filename);
		$filename = getArchiveCalendarRemoteImageFilename($filename);
		fwrite($fileObject, $remoteImage);
		fclose($fileObject);
		return array($originSrc, $filename, true);
	} else {
		return array(null, null, null);
	}
}

function getArchiveCalendarHTTPRemoteImage($remoteImage) {
    $response = '';
	$remoteStuff = parse_url($remoteImage);
	$port = isset($remoteStuff['port']) ? $remoteStuff['port'] : 80;

	$socket = @fsockopen($remoteStuff['host'], $port);
    fputs($socket, "GET " . $remoteStuff['path'] . " HTTP/1.1\r\n");
    fputs($socket, "Host: " . $remoteStuff['host'] . "\r\n");
    fputs($socket, "User-Agent: Mozilla/4.0 (compatible; Textcube)\r\n");
    fputs($socket, "Accept-Encoding: identity\r\n");
    fputs($socket, "Connection: close\r\n");
    fputs($socket, "\r\n");

	while ($buffer = fread($socket, 1024)) {
		$response .= $buffer;
	}

	preg_match('/Content-Length: ([0-9]+)/', $response, $matches);
	return substr($response, - $matches[1]);
}

function getArchiveCalendarRemoteImageFilename($filename) {
	requireComponent('Textcube.Function.Misc');
	$filename = md5($filename) . "." . Misc::getFileExtension($filename);
	return $filename;
}

function getArchiveCalendarPurgeCache($target, $mother) {
	requireComponent('Needlworks.Cache.PageCache');

	$context = Model_Context::getInstance();
	$dbPrefix = $context->getProperty('database.prefix');
	$blogid = $context->getProperty('blog.id');

	CacheControl::flushCategory();

	$cache = new pageCache;
	$archiveCalendars = POD::queryColumn("SELECT name
			FROM {$dbPrefix}PageCacheLog
			WHERE blogid = " . $blogid . "
			AND name like 'ArchiveCalendar\\_%'");
	CacheControl::purgeItems($archiveCalendars);

	unset($cache);
	return $target;
}

//function getArchiveCalendarDataSet($DATA){
//	requireComponent('Textcube.Function.misc');
//	$cfg = Misc::fetchConfigVal($DATA);
//	return true;
//}
?>